/*! \file ex3.cpp
 *  \brief Main file for 3rd programming exercise
 */

#include <iostream>

#include <adaptiveTriangMesh.h>
#include <configuratorsShellFE.h>
#include <EigenDataContainer.h>
#include <quadratureShellFE.h>
#include <shellHandler.h>
#include <triangleShellFE.h>

#include "errorMeasurements.h"
#include "errorEstimator.h"
#include "stiffnessMatrixIntegrator.h"

using namespace std;

// typedefs for better code readability
typedef double RealType;
typedef shellFE::ShellElementWithTangentSpaceAtVertex<DataTypeContainerShellFE> TriangleType;
typedef shellFE::AdaptiveTriangMesh<DataTypeContainerShellFE, TriangleType> MeshType;
typedef shellFE::CenterOfMassQuadrature<RealType, typename DataTypeContainerShellFE::DomVecType> QuadType;
typedef shellFE::UnitTriangMeshConfiguratorP1<DataTypeContainerShellFE, MeshType, QuadType> ConfiguratorType;

void printHelp()
{
    cout << "Usage: ex3 meshFile resultPrefix [numRefinements]\n";
    cout << "\tmeshFile\tLegacy VTK file defining the Finite Element mesh "
            << "to use\n";
    cout << "\tresultPrefix\tPrefix for result files, counter will be appended\n";
    cout << "\tnumRefinements\tNumber of times the mesh is refined"
            << " (default: 10)\n\n";
}

//! \brief Main function containing the basic structure of the code
int main(int argc, char **argv)
{
    unsigned int numRefinements = 10;
    switch (argc) {
    case 3: {
        // First two arguments are handled below
        break;
    }
    case 4: {
        numRefinements = atoi(argv[3]);
        break;
    }
    default: {
        printHelp();
        return 1;
    }
    }

    //! \todo Solve the equation
    //! \todo Refine the mesh
    //! \todo Output tables

    return 0;
}
